
#include "faimtest.h"
/*
 #include <readline/readline.h>
   #include <readline/history.h> 
*/
char irc_password[1024];
char irc_nick[1024];
char rl_line_buffer[8129];
char cur_chan_name[1024]; /* kludge */
int rl_line_pos = 0;
extern aim_frame_t *cur_chat_frame;

static int cmd_help(char *arg);
static int cmd_quit(char *arg);
static int cmd_login(char *arg);
static int cmd_logout(char *arg);
static int cmd_connlist(char *arg);
static int cmd_goodday(char *arg);
static int cmd_warn(char *arg);
static int cmd_anonwarn(char *arg);
static int cmd_sendmsg(char *arg);

static int cmd_irc_user(char *arg);
static int cmd_irc_nick(char *arg);
static int cmd_irc_pass(char *arg);
static int cmd_irc_privmsg(char *arg);
static int cmd_irc_userhost(char *arg);
static int cmd_irc_who(char *arg);
static int cmd_irc_join(char *arg);
static int cmd_irc_mode(char *arg);
static int cmd_irc_ping(char *arg);
static int cmd_irc_ison(char *arg);
static int cmd_irc_part(char *arg);

typedef int Function ();
#define whitespace(c) (((c) == ' ') || ((c) == '\t'))

struct {
	char *name;
	Function *func;
	char *doc;
} cmdlist[] = {
	{ "help", cmd_help, "Help"},
	{ "quit", cmd_quit, "Quit"},
	{ "USER", cmd_irc_user, "Specify a user name"},
	{ "PASS", cmd_irc_pass, "Specify a password"},
	{ "NICK", cmd_irc_nick, "Specify a nickname"},
	{ "PRIVMSG", cmd_irc_privmsg, "send a private message"},
	{ "USERHOST", cmd_irc_userhost, "does nothing"},
	{ "MODE", cmd_irc_mode, "spits out fake mode"},
	{ "WHO", cmd_irc_who, "spits out 1 user who"},
	{ "JOIN", cmd_irc_join, "joins a channel"},
	{ "PART", cmd_irc_part, "parts a channel"},
	{ "ISON", cmd_irc_ison, "parts a channel"},
	{ "PING", cmd_irc_ping, "server ping"},
	{ "login", cmd_login, "Log into AIM"},
	{ "logout", cmd_logout, "Log out of AIM"},
	{ "QUIT", cmd_quit, "Log out of AIM"},
	{ "connlist", cmd_connlist, "List open connections"},
	{ "goodday", cmd_goodday, "Say goodday to arg"},
	{ "warn", cmd_warn, "Warn arg"},
	{ "anonwarn", cmd_anonwarn, "Anonymously warn arg"},
	{ "sendmsg", cmd_sendmsg, "Send arg[0] bytes to arg[1]"},
	{ (char *)NULL, (Function *)NULL, (char *)NULL }
};

#define MAXLINE 8096

char *replace(char *string, char *oldpiece, char *newpiece) 
{ 
   int str_index, newstr_index, oldpiece_index, end, new_len, old_len, cpy_len; 
   char *c; 
   static char newstring[MAXLINE]; 

   if ((c = (char *) strstr(string, oldpiece)) == NULL) 
      return string; 


   new_len = strlen(newpiece); 
   old_len = strlen(oldpiece); 
   end = strlen(string) - old_len; 
   oldpiece_index = c - string; 


   newstr_index = 0; 
   str_index = 0; 
   while(str_index <= end && c != NULL) 
   { 
      /* Copy characters from the left of matched pattern occurence */ 
      cpy_len = oldpiece_index-str_index; 
      strncpy(newstring+newstr_index, string+str_index, cpy_len); 
      newstr_index += cpy_len; 
      str_index += cpy_len; 


      /* Copy replacement characters instead of matched pattern */ 
      strcpy(newstring+newstr_index, newpiece); 
      newstr_index += new_len; 
      str_index += old_len; 


      /* Check for another pattern match */ 
      if((c = (char *) strstr(string+str_index, oldpiece)) != NULL) 
         oldpiece_index = c - string; 
   } 
   /* Copy remaining characters from the right of last matched pattern */ 
   strcpy(newstring+newstr_index, string+str_index); 


   return newstring; 
} 


static char *stripwhite(char *string)
{
	char *s, *t;

	for (s = string; whitespace(*s); s++)
		;

	if (*s == 0)
		return (s);

	t = s + strlen (s) - 1;
	while (t > s && whitespace (*t))
		t--;
	*++t = '\0';

	return s;
}
/*
static char *cmdgenerator(const char *text, int state)
{
	static int list_index, len;
	char *name;

	if (!state) {
		list_index = 0;
		len = strlen (text);
	}

	while ((name = cmdlist[list_index].name)) {
		list_index++;
		if (strncmp (name, text, len) == 0)
			return (strdup(name));
	}

	/ If no names matched, then return NULL. /
	return (char *)NULL;
}
*/

static Function *cmdfind(char *name)
{
	int i;

	for (i = 0; cmdlist[i].name; i++) {
		if (strcmp (name, cmdlist[i].name) == 0)
			return cmdlist[i].func;
	}

	return NULL;
}

static int cmdexec(char *line)
{
	int i;
	Function *cmd;
	char *word;

	/* Isolate the command word. */
	i = 0;
	while (line[i] && whitespace (line[i]))
		i++;
	word = line + i;

	while (line[i] && !whitespace (line[i]))
		i++;

	if (line[i])
		line[i++] = '\0';

	if (!(cmd = cmdfind(word))) {
	  printf("NOTICE AUTH :ftzdomino2: invalid command: %s\n", word);
	  /*		fprintf(stdout, "%s: invalid command\n", word); */
		return -1;
	}
	/* Get argument to command, if any. */
	while (whitespace (line[i]))
		i++;

	word = line + i;

	/* Call the function. */
	return cmd(word);
}

static void fullline() 
{
	char *stripped;

	stripped = stripwhite(rl_line_buffer);

	if (*stripped) {
	  /*		add_history(stripped); */
		cmdexec(stripped);
	}

	return;
}

void cmd_init(void)
{

  /*	rl_attempted_completion_function = cmdcomplete; */

	/*	printf("Welcome to faimtest.\n"); */

	/*	rl_callback_handler_install("faimtest> ", fullline); */
  /*	rl_callback_handler_install("", fullline); */

	return;
}

void cmd_gotkey(void)
{
  /* need bounds checking! */
  /*	rl_callback_read_char(); */
  char c;
  read(0, &c, 1);
  if ((c == '\n') || (c == '\r')) // we're at the end of a line
    {
      if ( rl_line_pos != 0)
	{
	  rl_line_buffer[rl_line_pos]  = 0; /* terminate */
	  fullline();
	  rl_line_buffer[0] = 0;
	  rl_line_pos = 0;
	}
    }
  else
  {
    rl_line_buffer[rl_line_pos++] = c;
  }
  return;
}

static int cmd_help(char *arg)
{
	int i;

	for (i = 0; cmdlist[i].name; i++)
		printf("%16s\t\t%s\n", cmdlist[i].name, cmdlist[i].doc);

	return 0;
}

static int cmd_quit(char *arg)
{
	keepgoing = 0;

	return 0;
}

static int cmd_login(char *arg)
{
	char *sn = NULL, *passwd = NULL;

	if (arg) {
		sn = arg;
		if ((passwd = index(sn, ' '))) {
			*(passwd) = '\0';
			passwd++;
		}
	}

	if (login(&aimsess, sn, passwd) != 0)
		printf("login failed\n");

	return 0;
}

static int cmd_irc_user(char *arg) 
{
 if (strlen(irc_password) == 0)
	{
	  printf(":irctest 464 ftzdomino2 :need pass");
	}
      else
	{
	}
  /*    printf("logging in with --%s-- --%s--\n", irc_nick, irc_password); */
	return 0;
}

static int cmd_irc_nick(char *arg) 
{
  /* save nickname for later */
  if(arg)
    {
      strncpy(irc_nick, arg, sizeof(irc_password));
  /* now log in */
      if(strlen(irc_password) != 0)
	{
	  if (login(&aimsess, irc_nick, irc_password) != 0)
	    printf("login failed\n");
	}
      else
	{
	   printf("NOTICE AUTH :ftzdomino2: enter a password\n");
	}
    }
  return 0;
}

static int cmd_irc_userhost(char *arg)
{
  return 0;
}

static int cmd_irc_pass(char *arg)
{
	if (arg) {

	  /*		sn = arg;
		if ((passwd = index(sn, ' '))) {
			*(passwd) = '\0';
			passwd++;
			} */
	strncpy(irc_password, arg, sizeof(irc_password));

	}

	return 0;
}

static int cmd_logout(char *arg)
{
	logout(&aimsess);

	return 0;
}

static int cmd_connlist(char *arg)
{
	aim_conn_t *cur;

	printf("Open connections:\n");
	for (cur = aimsess.connlist; cur; cur = cur->next) 
		printf(" fd=%d  type=0x%02x\n", cur->fd, cur->type);

	return 0;
}

static int cmd_goodday(char *arg)
{
	if (arg && strlen(arg) && (strlen(arg) < MAXSNLEN))
		aim_send_im(&aimsess, aim_getconn_type(&aimsess, AIM_CONN_TYPE_BOS), arg, AIM_IMFLAGS_ACK, "Good day to you too.");
	else
		printf("no one to say hello to!\n");

	return 0;
}

static int cmd_warn(char *arg)
{
	if (arg && strlen(arg) && (strlen(arg) < MAXSNLEN))
		aim_send_warning(&aimsess, aim_getconn_type(&aimsess, AIM_CONN_TYPE_BOS), arg, 0);
	else
		printf("no one to warn!\n");

	return 0;
}

static int cmd_irc_mode(char *arg)
{
    printf(":irc.libfaim.com 324 %s #%s +nt\r\n", irc_nick, cur_chan_name); 
    printf(":irc.libfaim.com 329 %s #%s 1000852731\r\n", irc_nick, cur_chan_name); 
    return 0;
}

static int cmd_irc_who(char *arg)
{
  	  printf(":irc.libfaim.com 352 %s #%s abcdef 1.2.3.4 irc.faimirc.com %s H :0 you\r\n", irc_nick, cur_chan_name, irc_nick);
	  printf(":irc.libfaim.com 315 %s #%s :End of /WHO list..\r\n", irc_nick, cur_chan_name); 
	  return 0;
}

static int cmd_irc_join(char *arg)
{
  char chan_name[1024];
  char *name_start;
  
  name_start = index(arg, '#');
  name_start = &name_start[1];
  sprintf(chan_name, "!aol://2719:10-5-%s", replace(name_start, "_", "%20"));
  aim_chat_join(&aimsess, aimsess.connlist, 5, chan_name, 0);
  strcpy(cur_chan_name, name_start);
  return 0;
}

static int cmd_irc_part(char *arg)
{
  char chan_name[1024];
  char *name_start;
  
  name_start = index(arg, '#');
  name_start = &name_start[1];
  sprintf(chan_name, "!aol://2719:10-5-%s", replace(name_start, "_", "%20"));
  aim_chat_leaveroom(&aimsess, chan_name);
  return 0;  
}

static int cmd_irc_ping(char *arg)
{
  char *lag, *destserver;
  lag = strtok(arg, " ");
  destserver = strtok(NULL, " ");
  printf("PONG %s\r\n", arg);

  return 0;
}

static int cmd_irc_ison(char *arg)
{
  printf(":irc.faimirc.com 303 %s :%s\r\n", arg, arg);

  return 0;
}

static int cmd_anonwarn(char *arg)
{
	if (arg && strlen(arg) && (strlen(arg) < MAXSNLEN))
		aim_send_warning(&aimsess, aim_getconn_type(&aimsess, AIM_CONN_TYPE_BOS), arg, AIM_WARN_ANON);
	else
		printf("no one to anonwarn!\n");

	return 0;
}

static int cmd_irc_privmsg(char *arg)
{
  /*	int len = 0, z;
	char sn[MAXSNLEN+1], *newbuf = NULL; */
	char *sn, *message;

	/*	if ((sscanf(arg, "%d %32s", &len, sn) != 2) || 
			(len >= 10000) || (strlen(sn) > MAXSNLEN)) {
		printf("invalid args\n");
		return 0;
	}

	printf("sending %d bytes to %s\n", len, sn);

	if (!(newbuf = malloc(len+1)))
		return 0;

	for (z = 0; z < len; z++)
		newbuf[z] = (z % 10)+0x30;
		newbuf[len] = '\0'; */
	
	sn = arg;
	message = index(arg,' ');
	message[0] = 0; 
	message = &message[1];
	message += 1; /* get rid of colon */
	message = replace(message, "<", "&lt;");
	message = replace(message, ">", "&gt;");
	message = replace(message, "<", "&lt;");

	if (index(sn, '#') == NULL) /* really bad, but works for now */
	  {
	    aim_send_im(&aimsess, aim_getconn_type(&aimsess, AIM_CONN_TYPE_BOS), sn, AIM_IMFLAGS_ACK, message);
	  }
	else
	  {
	    if ( cur_chat_frame->conn != NULL)
	      {
		aim_chat_send_im(&aimsess, cur_chat_frame->conn, 0, message, strlen(message)); 
	      }
	    else
	      {
		printf("weird stuff happened.");
	      }
	  }

	/*	free(newbuf); */

	return 0;
}

static int cmd_sendmsg(char *arg)
{
	int len = 0, z;
	char sn[MAXSNLEN+1], *newbuf = NULL;

	if ((sscanf(arg, "%d %32s", &len, sn) != 2) || 
			(len >= 10000) || (strlen(sn) > MAXSNLEN)) {
		printf("invalid args\n");
		return 0;
	}

	printf("sending %d bytes to %s\n", len, sn);

	if (!(newbuf = malloc(len+1)))
		return 0;

	for (z = 0; z < len; z++)
		newbuf[z] = (z % 10)+0x30;
	newbuf[len] = '\0';

	aim_send_im(&aimsess, aim_getconn_type(&aimsess, AIM_CONN_TYPE_BOS), sn, AIM_IMFLAGS_ACK, newbuf);

	free(newbuf);

	return 0;
}

void cmd_uninit(void)
{

  /*	rl_callback_handler_remove(); */

	return;
}


